#include <STDIO.H>
#include "FSEDCONF.H"

main(argc,argv)
  int argc;
  char **argv;
{
  int i;

  maxcol = 79;
  column = 0;
  indent = 0;
  if (argc > 1)
  {
    maxcol = atoi(argv[1]);
    if (maxcol < 32)
      maxcol = 31;
    else
      maxcol--;
  }

  iobreak(0);

  initb(icoff, "17,10,11,4,5,6,7,8,9,18,19,22,23,20,21,29,12,13,14,25,15,24,28,27,16,26");
  initptr(ictxt, "key ENTER/RETURN", "insert tabulator - TAB", "toggle mode INS/OVR",
	"cursor left by char", "cursor right by char",
	"cursor left by word", "cursor right by word",
	"cursor to begin of line", "cursor to end of line",
	"cursor to previous line", "cursor to next line",
	"first text line", "last text line",
	"previous page", "next page",
	"backspace", "delete char at cursor",
	"delete text from line", "delete text right of cursor",
	"delete current line", "restore original line text",
	"duplicate line", "exchange lines",
	"set block boundary", "next ASCII character",
	"enter command mode", NULL);

  initb(ocoff, "36,37,42,51,60,69,78");
  initptr(octxt, "characters per row", "rows per screen",
	"set cursor position", "erase screen",
	"hide cursor", "show cursor", "bell", NULL);

  sprintf(strbuf,"\n* FSED v%d.%d Configuration Program *\n\n",
	(FSED_VER >> 4) & 15, FSED_VER & 15);
  p(strbuf)
  p("This program makes physical changes to the file FSED.COM")
  p("so as to customize console facilities of your terminal.\n\n")
  indent = 6;
  p("Note: You can run this program with one numeric parameter")
  p("which determines width of your terminal in characters. This ensures proper")
  p("word wrap of printed text in this program. Default value is 80.")
  indent = 0;
  p("\n\nDo NOT run this program until you have backed up your original FSED.COM file!\n\n")
  p("Have you backed up your original FSED.COM file in the current logged directory?")
  if (!ask(NULL))
  {
    p("\nThen do so now, and run this program again when ready.\n")
    exit();
  }

  read_block();
  movmem(secbuf, secbuf2, SECSIZ);

  setjmp(jbuf);

  i = *(secbuf + 3);
  if (i != FSED_VER)
  {
    sprintf(strbuf, "\nVersion of the FSED.COM (%d.%d) do not match version of the Configuration Program (%d.%d)!\n",
	(i >> 4) & 15, i & 15, (FSED_VER >> 4) & 15, FSED_VER & 15);
    p(strbuf)
    if (!ask("Do you want to continue?"))
      exit();
  }

  while (1)
  {
    for (i = 0; i < 12; i++)
    {
      if (!*(secbuf + 82 + i))
	break;
      *(strbuf + i) = *(secbuf + 82 + i);
    }
    *(strbuf + i) = '\n';
    i++;
    *(strbuf + i) = 0;

    p("\nMenu:\n")
    indent = 2;
    p("\n")
    p("1. Display input console settings\n")
    p("2. Edit input console settings\n")
    p("3. Display output console settings\n")
    p("4. Edit output console settings\n")
    p("5. Terminal name:")
    p(strbuf)
    p("0. Exit and save changes\n")
    indent = 0;
    p("\nYour option:")

    switch(getch())
    {
      case '1':
	disp_input();
	break;

      case '2':
	edit_input();
	break;

      case '3':
	disp_output();
	break;

      case '4':
	edit_output();
	break;

      case '5':
	edit_terminal_name();
	break;

      case '0':
        if (memcmp(secbuf, secbuf2, SECSIZ))
	  p("No changes specified.\n")
	else
	{
	  if (ask("\nWrite changes to disk?"))
	  {
	    write_block();
	    p("New FSED.COM written.\n")
	  }
	  else
	    p("Old configuration left intact.\n")
	}
	exit();
	break;

      default:
        p("Invalid selection. Try again...\n")
	break;
    }
  }
}

edit_terminal_name()
{
  int n, i;

  p("\n* Enter Terminal Name *\n\n")

  n = readline(strbuf, 12);
  for (i = 0; i < 12; i++)
  {
    if (i < n)
      *(secbuf + 82 + i) = *(strbuf + i);
    else
      *(secbuf + 82 + i) = 0;
  }
  p("\n")
}

disp_input()
{
  int i;

  p("\n* Input console settings *\n\n")
  sprintf(strbuf, "%-29sKey code  \n", "Function");
  p(strbuf)
  setmem(strbuf, strlen(strbuf) - 1, '-');
  p(strbuf)
  for (i = 0; i < IC_COUNT; i++)
  {
    sprintf(strbuf, "%-28s", ictxt[i]);
    p(strbuf)
    p(prep_code(secbuf[icoff[i]], strbuf));
    p("\n")
    if (i == (IC_COUNT / 2))
      pressKey();
  }
  p("\n")
}

edit_input()
{
  int m;

  p("\n* Edit Input console settings *\n\n")
  p("Now you can change the assignment of control keys for individual");
  p("editing operations. You can choose between two methods for selecting");
  p("the control key. In the first case, you enter code of control key.");
  p("In the second case, simply press the desired control key.\n");

  do {
    p("\n  1. entering code\n  2. pressing key\n");
    p("\n  Your option:")
    m = getch();
  } while (m != '1' && m != '2');

  if (m == '1')
    ed_inp_code();
  else
    ed_inp_key();
}

ed_inp_code()
{
  int i, l, v;
  char *q;

  p("\n\nYou should now enter control key codes for various editing operations");
  p("as a pair of HEX characters. Codes may be in the range 01 to 1F and 7F to FE.");
  p("To retain the original value, enter a blank line. If a given");
  p("editing operation you do not want to use, enter the value FF.\n");
  p("Back to the menu you can return any time by pressing Ctrl-Z.\n")

  for (i = 0; i < IC_COUNT; i++)
  {
    while (1)
    {
      printf("\n'%s' (%s):\n  ", ictxt[i], prep_code(secbuf[icoff[i]], strbuf));
      readline(strbuf, 2);
      trim(strbuf);
      l = strlen(strbuf);
      if (!l)
      {
	printf("Unchanged\n");
	break;
      }

      q = strbuf;
      v = parseValue(&q, 1, 0xFF);
      if (v < 0)
      {
	printf("\tBad entry!");
	continue;
      }
      /* <01,1F> or <7F,7E> or FF */
      if (!v || (v >= 0x20 && v <= 0x7E))
      {
        printf("\tBad value!");
	continue;
      }

      if (v != 0xFF)
      {
	for (l = 0; l < i; l++)
 	{
	  if (secbuf[icoff[l]] == v)
	  {
	    printf("\tCode used!");
	    break;
	  }
	}
	if (l < i)
	  continue;
      }

      secbuf[icoff[i]] = v;
      printf("\t%s\n", prep_code(v, strbuf));
      break;
    }
  }
}

ed_inp_key()
{
  int i, l, v;
  char *q;

  p("\n\nYou should now press control key for various editing operations.");
  p("Any such choice must be confirmed by pressing SPACE.");
  p("To retain the original value, press only SPACE. If a given");
  p("editing operation you do not want to use, press only dash '-'.\n");
  p("Back to the menu you can return any time by pressing 'Q'.\n")

  for (i = 0; i < IC_COUNT; i++)
  {
    while (1)
    {
      printf("\n'%s' (%s):\n  ", ictxt[i], prep_code(secbuf[icoff[i]], strbuf));
      v = bios(3, 0);
      if (v == 'Q' || v == 'q')
	longjmp(jbuf);
      else if (v == ' ')
      {
	printf("Unchanged\n");
	break;
      }
      else if (v == '-')
      {
	secbuf[icoff[i]] = 0xFF;
	printf("Undefined\n");
	break;
      }

      printf("%s\t", prep_code(v, strbuf));

      if (!v || (v >= 0x20 && v <= 0x7E))
      {
	printf("Bad entry!");
	continue;
      }

      for (l = 0; l < i; l++)
      {
	if (secbuf[icoff[l]] == v)
	{
	  printf("Key used!");
	  break;
	}
      }
      if (l < i)
	continue;

      printf("SPACE to confirm");
      if (bios(3, 0) != ' ')
	continue;

      secbuf[icoff[i]] = v;
      printf("\n");
      break;
    }
  }
}

disp_output()
{
  int i, j, b;

  p("\n* Output console settings *\n\n")
  sprintf(strbuf, "%-21sValue  \n", "Parameter");
  p(strbuf)
  setmem(strbuf, strlen(strbuf) - 1, '-');
  p(strbuf)
  for (i = 0; i < OC_COUNT; i++)
  {
    sprintf(strbuf, "%-20s", octxt[i]);
    p(strbuf)
    if (i < 2)
    {
      sprintf(strbuf, "%2d (DEC)", secbuf[ocoff[i]]);
      p(strbuf)
    }
    else
    {
      if (secbuf[ocoff[i]])
      {
	for (j = 0; j < 12; j++)
	{
	  if (i == 2 && (j == secbuf[38] || j == secbuf[39]))
	  {
	    if (j == secbuf[38]) {
	      if (!secbuf[40])
		strcpy(strbuf, "row");
	      else if (secbuf[40] == 128)
		strcpy(strbuf, "ascii-row");
	      else
		sprintf(strbuf, "row+%02x", secbuf[40]);
	    }
	    else {
	      if (!secbuf[41])
		strcpy(strbuf, "col");
	      else if (secbuf[41] == 128)
		strcpy(strbuf, "ascii-col");
	      else
		sprintf(strbuf, "col+%02x", secbuf[41]);
	    }
	    p(strbuf)
	    continue;
	  }

	  b = secbuf[ocoff[i] + j];
	  if (b)
	  {
	    sprintf(strbuf, "%02x", b);
	    p(strbuf)
	  }
	  else
	    break;
	}
      }
      else
	p("Undefined")
    }
    p("\n")
  }
  p("\n")
}

edit_output()
{
  int i, j, v;
  char *q;

  p("\nFSED needs to know some capabilities of your terminal.")
  p("\n(Back to the menu you can return any time by pressing Ctrl-Z.)\n")

  p("\nFirst you should enter width and height of your terminal screen.")
  p("Values must be in decimal. Blank line means no change.\n")

  for (i = 0; i < 2; i++)
  {
    while (1)
    {
      sprintf(strbuf, "\n'%s' (%d DEC):", octxt[i], secbuf[ocoff[i]]);
      p(strbuf)

      readline(strbuf, 3);
      trim(strbuf);
      v = strlen(strbuf);
      if (!v)
      {
	printf("\tUnchanged\n");
	break;
      }

      q = strbuf;
      v = parseValue(&q, 0, 126);
      if (v < 0)
      {
	printf("\tBad entry!");
	continue;
      }

      if (v < 16 || v > 126)
      {
	printf("\tBad value!");
	continue;
      }

      secbuf[ocoff[i]] = v;
      printf("\n");
      break;
    }
  }

  p("\nFSED also needs to know some escape code sequences of your terminal.")
  p("All values (codes) must be entered as a pair of HEX characters.")
  p("Values must be separated by spaces.")
  p("Some escape code sequences are mandatory, some optional.\n")
  p("To retain the original value(s), enter a blank line. If your terminal")
  p("does not support any of the optional operations, enter only the value 00.\n\n")

  pressKey();

  p("\nFirst, you need to specify mandatory escape sequence to set cursor position.")
  p("This escape sequence must contain row and column where the cursor should")
  p("be set. In your entry these must be marked using words 'row' and 'col'")
  p("(without apostrophes). In some cases, row and column must be adjusted")
  p("by a fixed constant or row and column must be in ASCII,")
  p("but this up in the next step.\n")

  for (i = 2; i < OC_COUNT; i++)
  {
    while (1)
    {
      sprintf(strbuf, "\nEnter escape sequence for '%s'", octxt[i]);
      p(strbuf)

      sprintf(strbuf, "(max. %d codes", (i == 6) ? 3 : 8);
      if (i == 2)
	strcat(strbuf, " including row and column marks");
      strcat(strbuf, ")\n(");
      p(strbuf)

      for (j = 0; j < 8; j++)
      {
	if (i == 2 && (j == secbuf[38] || j == secbuf[39]))
	{
	  if (j == secbuf[38])
	    strcpy(strbuf, "row");
	  else
	    strcpy(strbuf, "col");
	  p(strbuf)
	  continue;
	}

        v = secbuf[ocoff[i] + j];
        if (v || !j)
	{
	  if (v)
	  {
	    sprintf(strbuf, "%02x", v);
	    p(strbuf)
	  }
	  else
	    p("Undefined")
	}
	if (!v)
	  break;
      }
      p("):")

      v = readCodes(&secbuf[ocoff[i]], ((i == 6) ? 3 : 8), (i == 2), (i < 4));
      if (v >= 0)
	break;
    }

    if (i == 2 && v > 0)
    {
      p("\nRow and column are in [B]inary or [A]scii ?")
      while (1)
      {
	column = 0; /* prevent spurious newlines */
	j = toupper(getch());
	if (j == 'A' || j == 'B')
	  break;
	p("Please answer 'A' or 'B'.")
      }
      if (j == 'A') {
	secbuf[40] = 0x80;
	secbuf[41] = 0x80;
	continue;
      }

      for (j = 0; j < 2; j++)
      {
	sprintf(strbuf, "\nEnter value to adjust %s number:\n",
	  (j) ? "column" : "row");
	p(strbuf)
	readline(strbuf, 2);
	trim(strbuf);
	v = strlen(strbuf);
	if (!v)
	{
	  p("\tUnchanged\n")
	  continue;
	}
	q = strbuf;
	v = parseValue(&q, 1, 0xFF);
	if (v < 0)
	{
	  p("\tBad entry!")
	  j--;
	  continue;
 	}
	secbuf[40 + j] = v;
      }
    }

    p("\n")
  }
}

